Index: trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs	(revision 995)
@@ -27,7 +27,7 @@
       for (int i = 0; i < 10; i++) {
         Job job = new Job();
-        job.JobId = i;
+        job.Id = i;
         job.State = State.offline;
-        jobAdapter.UpdateJob(job);
+        jobAdapter.Update(job);
       }
 
@@ -40,6 +40,6 @@
       response.Success = true;
 
-      ICollection<ClientInfo> allClients = clientAdapter.GetAllClients();
-      ClientInfo client = clientAdapter.GetClientById(clientInfo.ClientId);
+      ICollection<ClientInfo> allClients = clientAdapter.GetAll();
+      ClientInfo client = clientAdapter.GetById(clientInfo.ClientId);
       if (client != null) {
         if (client.State != State.offline) {
@@ -50,5 +50,5 @@
 
       if (response.Success) {
-        clientAdapter.UpdateClient(clientInfo);
+        clientAdapter.Update(clientInfo);
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_LOGIN_SUCCESS;
       }
@@ -63,5 +63,5 @@
       response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_HARDBEAT_RECEIVED;
       response.ActionRequest = new List<MessageContainer>();
-      List<Job> allJobs = new List<Job>(jobAdapter.GetAllJobs());
+      List<Job> allJobs = new List<Job>(jobAdapter.GetAll());
       if (allJobs.Count > 0 && hbData.freeCores > 0) 
         response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.FetchJob));
@@ -75,8 +75,8 @@
       ResponseJob response = new ResponseJob();
       lock (this) {
-        LinkedList<Job> allJobs = new LinkedList<Job>(jobAdapter.GetAllJobs());
+        LinkedList<Job> allJobs = new LinkedList<Job>(jobAdapter.GetAll());
         if (allJobs.Last != null) {
-          response.JobId = allJobs.Last.Value.JobId;
-          jobAdapter.DeleteJob(allJobs.Last.Value);   
+          response.JobId = allJobs.Last.Value.Id;
+          jobAdapter.Delete(allJobs.Last.Value);   
           response.SerializedJob = PersistenceManager.SaveToGZip(new TestJob());
           response.Success = true;
@@ -102,5 +102,5 @@
       Response response = new Response();
       
-      ClientInfo client = clientAdapter.GetClientById(clientId);
+      ClientInfo client = clientAdapter.GetById(clientId);
       if (client == null) {
         response.Success = false;
@@ -109,5 +109,5 @@
       }
       client.State = State.offline;
-      clientAdapter.UpdateClient(client);
+      clientAdapter.Update(client);
 
       response.Success = true;
Index: trunk/sources/HeuristicLab.Hive.Server.Core/ClientManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/ClientManager.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/ClientManager.cs	(revision 995)
@@ -43,5 +43,5 @@
       clientGroups = new List<ClientGroup>();
 
-      ClientGroup cg = new ClientGroup { ResourceId = 4, Name = "SuperGroup" };
+      ClientGroup cg = new ClientGroup { Id = 4, Name = "SuperGroup" };
       cg.Resources = new List<Resource>();
 
@@ -54,5 +54,5 @@
       ResponseList<ClientInfo> response = new ResponseList<ClientInfo>();
 
-      response.List = new List<ClientInfo>(clientAdapter.GetAllClients());
+      response.List = new List<ClientInfo>(clientAdapter.GetAll());
       response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_ALL_CLIENTS;
       response.Success = true;
@@ -64,5 +64,5 @@
       ResponseList<ClientGroup> response = new ResponseList<ClientGroup>();
 
-      response.List = new List<ClientGroup>(clientGroupAdapter.GetAllClientGroups());
+      response.List = new List<ClientGroup>(clientGroupAdapter.GetAll());
       response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_ALL_CLIENTGROUPS;
       response.Success = true;
@@ -80,10 +80,10 @@
       Response response = new Response();
 
-      if (clientGroup.ResourceId != 0) {
+      if (clientGroup.Id != 0) {
         response.Success = false;
         response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_ID_MUST_NOT_BE_SET;
         return response;
       }
-      clientGroupAdapter.UpdateClientGroup(clientGroup);
+      clientGroupAdapter.Update(clientGroup);
       response.Success = true;
       response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_ADDED;
@@ -95,5 +95,5 @@
       Response response = new Response();
 
-      if (resource.ResourceId != 0) {
+      if (resource.Id != 0) {
         response.Success = false;
         response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_ID_MUST_NOT_BE_SET;
@@ -101,5 +101,5 @@
       }
 
-      ClientGroup clientGroup = clientGroupAdapter.GetClientGroupById(clientGroupId);
+      ClientGroup clientGroup = clientGroupAdapter.GetById(clientGroupId);
       if (clientGroup == null) {
         response.Success = false;
@@ -118,5 +118,5 @@
       Response response = new Response();
 
-      ClientGroup clientGroup = clientGroupAdapter.GetClientGroupById(clientGroupId);
+      ClientGroup clientGroup = clientGroupAdapter.GetById(clientGroupId);
       if (clientGroup == null) {
         response.Success = false;
@@ -125,5 +125,5 @@
       }
       foreach (Resource resource in clientGroup.Resources) {
-        if (resource.ResourceId == resourceId) {
+        if (resource.Id == resourceId) {
           clientGroup.Resources.Remove(resource);
           response.Success = true;
Index: trunk/sources/HeuristicLab.Hive.Server.Core/DbTestApp.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/DbTestApp.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/DbTestApp.cs	(revision 995)
@@ -43,8 +43,8 @@
       client.Login = DateTime.Now;
       client.ClientId = Guid.NewGuid();
-      clientAdapter.UpdateClient(client);
+      clientAdapter.Update(client);
 
       ClientInfo clientRead =
-        clientAdapter.GetClientById(client.ClientId);
+        clientAdapter.GetById(client.ClientId);
       Debug.Assert(
         clientRead != null &&
@@ -52,7 +52,7 @@
 
       client.CpuSpeedPerCore = 2000;
-      clientAdapter.UpdateClient(client);
+      clientAdapter.Update(client);
       clientRead =
-        clientAdapter.GetClientById(client.ClientId);
+        clientAdapter.GetById(client.ClientId);
       Debug.Assert(
        clientRead != null &&
@@ -60,10 +60,11 @@
        clientRead.CpuSpeedPerCore == 2000);
 
-      ICollection<ClientInfo> clients = clientAdapter.GetAllClients();
+      ICollection<ClientInfo> clients = 
+        clientAdapter.GetAll();
       int count = clients.Count;
 
-      clientAdapter.DeleteClient(client);
-
-      clients = clientAdapter.GetAllClients();
+      clientAdapter.Delete(client);
+
+      clients = clientAdapter.GetAll();
       Debug.Assert(count - 1 == clients.Count);
     }
@@ -74,18 +75,18 @@
 
       User user = new User();
-      user.Name = "Stefan";
-
-      userAdapter.UpdateUser(user);
+      user.Name = "TestDummy";
+
+      userAdapter.Update(user);
 
       User userRead =
-        userAdapter.GetUserById(user.PermissionOwnerId);
+        userAdapter.GetById(user.Id);
       Debug.Assert(
         userRead != null &&
-        user.PermissionOwnerId == userRead.PermissionOwnerId);
+        user.Id == userRead.Id);
 
       user.Password = "passme";
-      userAdapter.UpdateUser(user);
+      userAdapter.Update(user);
       userRead =
-        userAdapter.GetUserByName(user.Name);
+        userAdapter.GetByName(user.Name);
       Debug.Assert(
        userRead != null &&
@@ -93,10 +94,11 @@
        userRead.Password == user.Password);
 
-      ICollection<User> users = userAdapter.GetAllUsers();
+      ICollection<User> users = 
+       userAdapter.GetAll();
       int count = users.Count;
 
-      userAdapter.DeleteUser(user);
-
-      users = userAdapter.GetAllUsers();
+      userAdapter.Delete(user);
+
+      users = userAdapter.GetAll();
       Debug.Assert(count - 1 == users.Count);
     }
@@ -129,35 +131,35 @@
       group.Members.Add(subGroup);
 
-      userGroupAdapter.UpdateUserGroup(group);
+      userGroupAdapter.Update(group);
 
       UserGroup read =
-        userGroupAdapter.GetUserGroupById(group.PermissionOwnerId);
+        userGroupAdapter.GetById(group.Id);
 
       ICollection<UserGroup> userGroups =
-        userGroupAdapter.GetAllUserGroups();
+        userGroupAdapter.GetAll();
 
       IUserAdapter userAdapter =
         ServiceLocator.GetUserAdapter();
 
-      userAdapter.DeleteUser(user3);
+      userAdapter.Delete(user3);
       
       read =
-         userGroupAdapter.GetUserGroupById(group.PermissionOwnerId);
-
-      userGroupAdapter.DeleteUserGroup(subGroup);
-
-      read =
-         userGroupAdapter.GetUserGroupById(group.PermissionOwnerId);
+         userGroupAdapter.GetById(group.Id);
+
+      userGroupAdapter.Delete(subGroup);
+
+      read =
+         userGroupAdapter.GetById(group.Id);
 
       userGroups =
-        userGroupAdapter.GetAllUserGroups();
-
-      userGroupAdapter.DeleteUserGroup(group);
+        userGroupAdapter.GetAll();
+
+      userGroupAdapter.Delete(group);
 
       userGroups =
-        userGroupAdapter.GetAllUserGroups();
-
-      userAdapter.DeleteUser(user);
-      userAdapter.DeleteUser(user2);
+        userGroupAdapter.GetAll();
+
+      userAdapter.Delete(user);
+      userAdapter.Delete(user2);
     }
 
@@ -195,35 +197,35 @@
       group.Resources.Add(subGroup);
 
-      clientGroupAdapter.UpdateClientGroup(group);
+      clientGroupAdapter.Update(group);
 
       ClientGroup read =
-        clientGroupAdapter.GetClientGroupById(group.ResourceId);
+        clientGroupAdapter.GetById(group.Id);
 
       ICollection<ClientGroup> clientGroups =
-        clientGroupAdapter.GetAllClientGroups();
+        clientGroupAdapter.GetAll();
 
       IClientAdapter clientAdapter =
         ServiceLocator.GetClientAdapter();
 
-      clientAdapter.DeleteClient(client3);
-
-      read =
-         clientGroupAdapter.GetClientGroupById(group.ResourceId);
-
-      clientGroupAdapter.DeleteClientGroup(subGroup);
-
-      read =
-         clientGroupAdapter.GetClientGroupById(group.ResourceId);
+      clientAdapter.Delete(client3);
+
+      read =
+         clientGroupAdapter.GetById(group.Id);
+
+      clientGroupAdapter.Delete(subGroup);
+
+      read =
+         clientGroupAdapter.GetById(group.Id);
 
       clientGroups =
-        clientGroupAdapter.GetAllClientGroups();
-
-      clientGroupAdapter.DeleteClientGroup(group);
+        clientGroupAdapter.GetAll();
+
+      clientGroupAdapter.Delete(group);
 
       clientGroups =
-        clientGroupAdapter.GetAllClientGroups();
-
-      clientAdapter.DeleteClient(client);
-      clientAdapter.DeleteClient(client2);
+        clientGroupAdapter.GetAll();
+
+      clientAdapter.Delete(client);
+      clientAdapter.Delete(client2);
     }
 
@@ -238,24 +240,31 @@
 
       job.Client = client;
-      jobAdapter.UpdateJob(job);
-
-      ICollection<Job> jobs = jobAdapter.GetAllJobs();
-
-      jobAdapter.DeleteJob(job);
-
-      jobs = jobAdapter.GetAllJobs();
+      jobAdapter.Update(job);
+
+      ICollection<Job> jobs = jobAdapter.GetAll();
+
+      jobAdapter.Delete(job);
+
+      jobs = jobAdapter.GetAll();
     }
 
     public override void Run() {
-      TestClientAdapter();
-      TestUserAdapter();
-      TestUserGroupAdapter();
-      TestClientGroupAdapter();
-      TestJobAdapter();
-
       ITransactionManager transactionManager =
         ServiceLocator.GetTransactionManager();
-
+      
+      TestClientAdapter();
       transactionManager.UpdateDB();
+
+      TestUserAdapter();
+      transactionManager.UpdateDB();
+
+      TestUserGroupAdapter();
+      transactionManager.UpdateDB();
+
+      TestClientGroupAdapter();
+      transactionManager.UpdateDB();  
+
+      TestJobAdapter();
+      transactionManager.UpdateDB();     
     }
   }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/HeuristicLab.Hive.Server.Core.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/HeuristicLab.Hive.Server.Core.csproj	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/HeuristicLab.Hive.Server.Core.csproj	(revision 995)
@@ -73,4 +73,5 @@
     <Compile Include="InternalInterfaces\DataAccess\IClientAdapter.cs" />
     <Compile Include="InternalInterfaces\DataAccess\IClientGroupAdapter.cs" />
+    <Compile Include="InternalInterfaces\DataAccess\IDataAdapter.cs" />
     <Compile Include="InternalInterfaces\DataAccess\IJobAdapter.cs" />
     <Compile Include="InternalInterfaces\DataAccess\IPermissionOwnerAdapter.cs" />
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IClientAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IClientAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IClientAdapter.cs	(revision 995)
@@ -30,18 +30,5 @@
   /// The client database adapter
   /// </summary>
-  public interface IClientAdapter {
-    /// <summary>
-    /// Save or update the client
-    /// </summary>
-    /// <param name="client"></param>
-    void UpdateClient(ClientInfo client);
-
-    /// <summary>
-    /// Get the client with the specified ID
-    /// </summary>
-    /// <param name="clientId"></param>
-    /// <returns></returns>
-    ClientInfo GetClientById(Guid clientId);
-
+  public interface IClientAdapter : IDataAdapter<ClientInfo> {
     /// <summary>
     /// Get the client with the specified name
@@ -49,24 +36,12 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    ClientInfo GetClientByName(string name);
+    ClientInfo GetByName(string name);
 
     /// <summary>
-    /// Get the client with the specified ID
+    /// Get the client with the specified id
     /// </summary>
     /// <param name="clientId"></param>
     /// <returns></returns>
-    ClientInfo GetClientById(long id);
-
-    /// <summary>
-    /// Get all clients
-    /// </summary>
-    /// <returns></returns>
-    ICollection<ClientInfo> GetAllClients();
-
-    /// <summary>
-    /// Deletes the client
-    /// </summary>
-    /// <param name="client"></param>
-    bool DeleteClient(ClientInfo client);
+    ClientInfo GetById(Guid id);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IClientGroupAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IClientGroupAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IClientGroupAdapter.cs	(revision 995)
@@ -30,18 +30,5 @@
   /// The client group database adapter
   /// </summary>
-  public interface IClientGroupAdapter {
-    /// <summary>
-    /// Save or update the client group
-    /// </summary>
-    /// <param name="client"></param>
-    void UpdateClientGroup(ClientGroup group);
-
-    /// <summary>
-    /// Get the client group with the specified ID
-    /// </summary>
-    /// <param name="clientId"></param>
-    /// <returns></returns>
-    ClientGroup GetClientGroupById(long clientGroupId);
-
+  public interface IClientGroupAdapter: IDataAdapter<ClientGroup> {
     /// <summary>
     /// Get the client group with the specified name
@@ -49,11 +36,5 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    ClientGroup GetClientGroupByName(string name);
-
-    /// <summary>
-    /// Get all client groups
-    /// </summary>
-    /// <returns></returns>
-    ICollection<ClientGroup> GetAllClientGroups();
+    ClientGroup GetByName(string name);
 
     /// <summary>
@@ -63,10 +44,4 @@
     /// <returns></returns>
     ICollection<ClientGroup> MemberOf(Resource resource);
-
-    /// <summary>
-    /// Deletes the client group
-    /// </summary>
-    /// <param name="client"></param>
-    bool DeleteClientGroup(ClientGroup group);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IDataAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IDataAdapter.cs	(revision 995)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IDataAdapter.cs	(revision 995)
@@ -0,0 +1,54 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess {
+  public interface IDataAdapter<ObjT> {
+    /// <summary>
+    /// Save or update the object
+    /// </summary>
+    /// <param name="user"></param>
+    void Update(ObjT ob);
+
+    /// <summary>
+    /// Get the object with the specified ID
+    /// </summary>
+    /// <param name="userId"></param>
+    /// <returns></returns>
+    ObjT GetById(long id);
+
+    /// <summary>
+    /// Get all objects
+    /// </summary>
+    /// <returns></returns>
+    ICollection<ObjT> GetAll();
+
+    /// <summary>
+    /// Deletes the object
+    /// </summary>
+    /// <param name="user"></param>
+    bool Delete(ObjT obj);
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IJobAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IJobAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IJobAdapter.cs	(revision 995)
@@ -27,24 +27,5 @@
 
 namespace HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess {
-  public interface IJobAdapter {
-    /// <summary>
-    /// Save or update the job
-    /// </summary>
-    /// <param name="client"></param>
-    void UpdateJob(Job job);
-
-    /// <summary>
-    /// Get the job with the specified ID
-    /// </summary>
-    /// <param name="clientId"></param>
-    /// <returns></returns>
-    Job GetJobById(long id);
-
-    /// <summary>
-    /// Get all jobs
-    /// </summary>
-    /// <returns></returns>
-    ICollection<Job> GetAllJobs();
-
+  public interface IJobAdapter: IDataAdapter<Job> {
     /// <summary>
     /// Gets all subjobs of the specified job
@@ -73,10 +54,4 @@
     /// <returns></returns>
     ICollection<Job> GetJobsOf(User user);
-
-    /// <summary>
-    /// Deletes the job
-    /// </summary>
-    /// <param name="client"></param>
-    bool DeleteJob(Job job);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IPermissionOwnerAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IPermissionOwnerAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IPermissionOwnerAdapter.cs	(revision 995)
@@ -30,11 +30,5 @@
   /// The permission owner database adapter
   /// </summary>
-  public interface IPermissionOwnerAdapter {
-    /// <summary>
-    /// Save or update the permission owner
-    /// </summary>
-    /// <param name="client"></param>
-    void UpdatePermissionOwner(PermissionOwner permOwner);
-
+  public interface IPermissionOwnerAdapter: IDataAdapter<PermissionOwner> {
     /// <summary>
     /// Gets the permission owner and updates the values of the object
@@ -42,12 +36,5 @@
     /// <param name="resource"></param>
     /// <returns></returns>
-    bool GetPermissionOwnerById(PermissionOwner permOwner);
-
-    /// <summary>
-    /// Get the permission owner with the specified ID
-    /// </summary>
-    /// <param name="clientId"></param>
-    /// <returns></returns>
-    PermissionOwner GetPermissionOwnerById(long permOwnerId);
+    bool GetById(PermissionOwner permOwner);
 
     /// <summary>
@@ -56,17 +43,5 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    PermissionOwner GetPermissionOwnerByName(String name);
-
-    /// <summary>
-    /// Get all permission owners
-    /// </summary>
-    /// <returns></returns>
-    ICollection<PermissionOwner> GetAllPermissionOwners();
-
-    /// <summary>
-    /// Deletes the permission owner
-    /// </summary>
-    /// <param name="permOwner"></param>
-    bool DeletePermissionOwner(PermissionOwner permOwner);
+    PermissionOwner GetByName(String name);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IResourceAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IResourceAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IResourceAdapter.cs	(revision 995)
@@ -30,17 +30,11 @@
   /// The resource database adapter
   /// </summary>
-  public interface IResourceAdapter {
+  public interface IResourceAdapter: IDataAdapter<Resource> {
     /// <summary>
-    /// Save or update the resource
+    /// Gets the resource and updates the values of the object
     /// </summary>
-    /// <param name="client"></param>
-    void UpdateResource(Resource resource);
-
-    /// <summary>
-    /// Get the resource with the specified ID
-    /// </summary>
-    /// <param name="clientId"></param>
+    /// <param name="resource"></param>
     /// <returns></returns>
-    Resource GetResourceById(long resourceId);
+    bool GetById(Resource resource);
 
     /// <summary>
@@ -49,24 +43,5 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    Resource GetResourceByName(string name);
-
-    /// <summary>
-    /// Gets the resource and updates the values of the object
-    /// </summary>
-    /// <param name="resource"></param>
-    /// <returns></returns>
-    bool GetResourceById(Resource resource);
-
-    /// <summary>
-    /// Get all resuorces
-    /// </summary>
-    /// <returns></returns>
-    ICollection<Resource> GetAllResources();
-
-    /// <summary>
-    /// Deletes the resource
-    /// </summary>
-    /// <param name="client"></param>
-    bool DeleteResource(Resource resource);
+    Resource GetByName(string name);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserAdapter.cs	(revision 995)
@@ -30,18 +30,5 @@
   /// The user database adapter
   /// </summary>
-  public interface IUserAdapter {
-    /// <summary>
-    /// Save or update the user
-    /// </summary>
-    /// <param name="user"></param>
-    void UpdateUser(User user);
-
-    /// <summary>
-    /// Get the user with the specified ID
-    /// </summary>
-    /// <param name="userId"></param>
-    /// <returns></returns>
-    User GetUserById(long userId);
-
+  public interface IUserAdapter: IDataAdapter<User> {
     /// <summary>
     /// Get the user with the specified name
@@ -49,17 +36,5 @@
     /// <param name="userId"></param>
     /// <returns></returns>
-    User GetUserByName(string name);
-
-    /// <summary>
-    /// Get all users
-    /// </summary>
-    /// <returns></returns>
-    ICollection<User> GetAllUsers();
-
-    /// <summary>
-    /// Deletes the user
-    /// </summary>
-    /// <param name="user"></param>
-    bool DeleteUser(User user);
+    User GetByName(string name);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserGroupAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserGroupAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/InternalInterfaces/DataAccess/IUserGroupAdapter.cs	(revision 995)
@@ -30,18 +30,5 @@
   /// The user group database adapter
   /// </summary>
-  public interface IUserGroupAdapter {
-    /// <summary>
-    /// Save or update the user group
-    /// </summary>
-    /// <param name="client"></param>
-    void UpdateUserGroup(UserGroup group);
-
-    /// <summary>
-    /// Get the user group with the specified ID
-    /// </summary>
-    /// <param name="clientId"></param>
-    /// <returns></returns>
-    UserGroup GetUserGroupById(long userGroupId);
-
+  public interface IUserGroupAdapter: IDataAdapter<UserGroup> {
     /// <summary>
     /// Get the user group with the specified name
@@ -49,11 +36,5 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    UserGroup GetUserGroupByName(string name);
-
-    /// <summary>
-    /// Get all user groups
-    /// </summary>
-    /// <returns></returns>
-    ICollection<UserGroup> GetAllUserGroups();
+    UserGroup GetByName(String name);
 
     /// <summary>
@@ -63,10 +44,4 @@
     /// <returns></returns>
     ICollection<UserGroup> MemberOf(PermissionOwner permOwner);
-
-    /// <summary>
-    /// Deletes the user group
-    /// </summary>
-    /// <param name="client"></param>
-    bool DeleteUserGroup(UserGroup group);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/JobManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/JobManager.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/JobManager.cs	(revision 995)
@@ -43,5 +43,5 @@
       ResponseList<Job> response = new ResponseList<Job>();
 
-      response.List = new List<Job>(jobAdapter.GetAllJobs());
+      response.List = new List<Job>(jobAdapter.GetAll());
       response.Success = true;
       response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ALL_JOBS;
@@ -54,10 +54,10 @@
 
       if (job != null) {
-        if (job.JobId != 0) {
+        if (job.Id != 0) {
           response.Success = false;
           response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ID_MUST_NOT_BE_SET;
           return response;
         }
-        jobAdapter.UpdateJob(job);
+        jobAdapter.Update(job);
         response.Success = true;
         response.Obj = job;
@@ -74,5 +74,5 @@
       Response response = new Response();
 
-      Job job = jobAdapter.GetJobById(jobId);
+      Job job = jobAdapter.GetById(jobId);
       if (job == null) {
         response.Success = false;
@@ -80,5 +80,5 @@
         return response;
       }
-      jobAdapter.DeleteJob(job);
+      jobAdapter.Delete(job);
       response.Success = false;
       response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_REMOVED;
